{% macro render_products_section(supplier=None) %}
    <div class="category-page-content">
        {% placeholder "category_top_extra_global" global %}{% endplaceholder %}
        {% placeholder "category_top_extra" %}{% endplaceholder %}

        <div class="flex-row">
            <div class="col category-sidebar hidden-xs hidden-sm">
                {{ render_category_menu() }}
            </div>

            <div class="col category-main">
                {{ render_information() }}
                {{ render_product_filters_toggle() }}
                {{ render_product_list(supplier) }}
            </div>
        </div>

        {% placeholder "category_bottom_extra_global" global %}{% endplaceholder %}
        {% placeholder "category_bottom_extra" %}{% endplaceholder %}
    </div>
{% endmacro %}

{% macro render_information() %}
    {% if category.description %}
        <div class="category-description">
            <p class="lead">{{ category.description|safe }}</p>
        </div>
    {% endif %}
{% endmacro %}

{% macro render_product_list(supplier=None) %}
    <div id="ajax_content">
        {% set pagination = shuup.general.get_pagination_variables(products, page_size or 12) %}
        <div class="product-list-grid">
            {% for product in pagination.objects if shuup.product.is_visible(product) %}
                <div class="col single-product">
                    {{ product_box(
                        product,
                        thumbnail_size=(500,500),
                        show_description=False,
                        class="product-card category-view",
                        supplier=supplier,
                        show_actions=True)
                    }}
                </div>
            {% else %}
                <div class="col">
                    <em class="lead text-muted">{% trans %}No products{% endtrans %}</em>
                </div>
            {% endfor %}
        </div>
        {% if pagination.is_paginated %}
            <div class="bottom-pagination">
                {{ render_pagination(pagination.page, pagination.paginator, pagination.page_range) }}
            </div>
        {% endif %}
    </div>
{% endmacro %}

{% macro render_category_menu() %}
    <div class="category-menu">
        {% for c in root_categories %}
            {% if category and c in category.get_ancestors(include_self=True) %}
                {% set children = c.get_children() %}
                {% if children %}
                    {{ render_category_submenu(children) }}
                {% endif %}
            {% endif %}
        {% endfor %}
    </div>
{% endmacro %}

{% macro render_category_submenu(items) %}
    {% for c in items recursive %}
        {% set children = c.get_children() %}
        {% if c.level == 1 %}
            <ul>
                <li class="category-menu-title">
                    {{ c.name }}
                </li>
                <li class="{{ c.level }}{% if category and c == category %} current{% endif %}">
                    <a href="{{ url('shuup:category', pk=c.pk, slug=c.slug) }}">
                        {% trans category = c.name %}All in {{ category }}{% endtrans %}
                    </a>
                    {% if children %}
                        {{ loop(children) }}
                    {% endif %}
                </li>
            </ul>
        {% else %}
            <li class="{{ c.level }}{% if category and c == category %} current{% endif %}">
                <a href="{{ url('shuup:category', pk=c.pk, slug=c.slug) }}">
                    {{ c.name }}
                </a>
                {% if children %}
                    {{ loop(children) }}
                {% endif %}
            </li>
        {% endif %}
    {% endfor %}
{% endmacro %}

{% macro render_product_filters_toggle() %}
    <div class="category-filter-toggle-wrap">
        <button class="canvas-filters-dialog__toggler btn"
                id="canvas-filters-dialog__toggler"
                type="button"
                aria-haspopup="true"
                aria-controls="canvas-filters-dialog"
                aria-expanded="false"
        >
            {% trans %}Filters{% endtrans %} <i class="fa fa-filter fa-lg" aria-hidden="true"></i>
        </button>
    </div>
{% endmacro %}

{% macro render_product_filters() %}
    <div class="canvas-dialog canvas-dialog__right canvas-filters-dialog" id="canvas-filters-dialog" tabindex="-1">
        <button type="button"
                class="canvas-dialog__close-btn"
                id="canvas-filters-dialog__close-btn"
                aria-label="{% trans %}Close filters{% endtrans %}"
        >
            <svg class="canvas-nav-icon" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 53.46 53.36"><g fill="currentColor" id="Layer_2" data-name="Layer 2"><g id="Layer_1-2" data-name="Layer 1"><polygon points="53.46 4.38 49.08 0 26.78 22.3 4.48 0 0 4.38 22.3 26.68 0 48.98 4.48 53.36 26.78 31.06 49.08 53.36 53.46 48.98 31.16 26.68 53.46 4.38"/></g></g></svg>
        </button>

        <h2 class="mt-0 mb-5">{% trans %}Filters{% endtrans %}</h2>

        {% if "sort" in form.fields.keys() %}
            {{ render_field(form.sort) }}
        {% endif %}

        {% if "limit" in form.fields.keys() %}
            {{ render_field(form.limit) }}
        {% endif %}

        {% set fields = xtheme.get_product_filter_fields(form, exclude=["sort", "q", "limit"]) %}
        {% if fields %}
            {% for field in fields %}
                {% if field.field.widget.is_hidden %}
                    {{ field.as_widget()|safe }}
                {% else %}
                    <div class="filter-block">
                        <a href="#list_filters_{{ field.name }}"
                        class="block-title collapsed"
                        data-toggle="collapse"
                        aria-expanded="false"
                        aria-controls="list_filters_{{ field.name }}"
                        >
                            {{ field.label }}
                            <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                                <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                                <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                            </svg>
                            <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                                <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                            </svg>
                        </a>

                        <div id="list_filters_{{ field.name }}" class="collapse" aria-expanded="false">
                            <div class="collapsible-content">
                                {{ bs3.field(field, render_label=False) }}
                            </div>
                        </div>
                    </div>
                {% endif %}
            {% endfor %}
            <div id="clear-all-filters" class="hidden">
                <a href="{{ request.path }}">{% trans %}Clear all{% endtrans %}</a>
            </div>
        {% endif %}
    </div>

    <div class="canvas-dialog__page-fade-filters"></div>
{% endmacro %}
